config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :committees do
    match 'trials', to: 'trials#clear_permitted_trials', via: :delete, as: 'trial_clear_permitted'
    resources :trials do
      match 'state/:state_id', to: 'trials#set_state', via: :patch, as: 'set_state'
      match 'authorize/:private_key_digest', to: 'trials#receive_private_key_digest', via: :get,
                                             as: :authorize
      match '', to: 'trials#receive_private_key', via: :post
      match 'versions', to: 'trials#versions', via: :get
      match 'versions', to: 'trials#delete_versions', via: :delete
      match 'comment', to: 'trials#comment', via: :post
      resources :tasks, only: [:create, :update, :destroy, :edit]
      post 'upload', to: 'trials#upload'
    end
    resources :ranks, only: [:create, :destroy]
    resources :environments, only: [:create, :destroy, :edit, :update]
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get
  match 'permitted_keywords' => 'home#permitted_keywords', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/controllers/home_controller.rb
# frozen_string_literal: true
class HomeController < ApplicationController
  skip_before_action :login_required, only: [:index, :permitted_keywords]
  skip_committee_actions

  def index
    redirect_to committees_path if current_user.present?
  end

  def private_index; end

  def permitted_keywords
    respond_to do |format|
      format.json do
        message = '&alert=' + URI.escape(t(:no_trials_found)) if session[:permitted_trials].blank?
        message = '&alert=' + URI.escape(t(:trial_created_error)) if any_permitted_trials_created?
        redirect_to Rails.application.secrets.formsub_url + '/set_permitted_keywords?keywords=' +
                    URI.escape(Trial.pending.where(private_key_digest: session[:permitted_trials])
                                    .pluck(:formsub_case_keyword).compact.to_json) + message.to_s
      end
      format.html { head :no_content }
    end
  end
end

app/views/home/index.html.haml
= render 'shared/alerts'

- if current_user.present?
  %h1= t(:welcome)
  %p
    Username: #{current_user.email}
  .btn-group
    = link_to 'Private page', home_private_index_path,
    class: 'btn btn-secondary'
    = link_to 'Committees', committees_path, class: 'btn btn-primary'
    = link_to 'Logout', logout_path, method: :delete, class: 'btn btn-danger'
- else
  .col-md-6.offset-md-3
    %ul.nav.nav-tabs#landing-tabs{ role: 'tablist' }
      %li.nav-item
        %a.nav-link.active{ 'data-toggle': 'tab', href: '#home', role: 'tab' }
          %i.fa.fa-home
      %li.nav-item
        %a.nav-link{ 'data-toggle': 'tab', href: '#intro', role: 'tab' }
          %i.fa.fa-film
      %li.nav-item
        %a.nav-link{ 'data-toggle': 'tab', href: '#docs', role: 'tab' }
          %i.fa.fa-file

    .tab-content
      .tab-pane.active#home{ role: 'tabpanel' }
        .card
          %h3.card-header= t(:login_required)
          .card-block
            %h4.card-title= t(:plese_log_in)
            %p.card-text.pr-lg-5.text-justify
              = t(:log_in_more_info)
              %hr
              = t(:with_any_troubles)
              = mail_to(Rails.application.secrets.admin_email)
            = link_to t(:sign_in).capitalize, '/auth/sso',
            class: 'btn btn-success'
      .tab-pane#intro{ role: 'tabpanel' }
        .card
          %h3.card-header= t(:presentation)
          .card-block
            %h4.card-title= t(:meet_zaki)
            %p.card-text.pr-lg-5.text-justify
              = t(:starting_point)
              %b= link_to 'bit.ly/meet-zaki', 'https://bit.ly/meet-zaki',
              target: '_blank'
              %br
              = t(:visit_project_page)
              = link_to 'gitlab.com/modorg/zaki',
              'https://gitlab.com/modorg/zaki', target: '_blank'
              %hr
              = t(:or_add_fixes)
              = mail_to 'incoming+modorg/zaki@incoming.gitlab.com',
              'incoming+modorg/zaki@incoming.gitlab.com'
              %hr
              = t(:with_any_troubles)
              = mail_to(Rails.application.secrets.admin_email)
      .tab-pane#docs{ role: 'tabpanel' }
        .card
          %h3.card-header= t(:documentation)
          .card-block
            %h4.card-title= t(:dunno_how_to_start)
            %p.card-text.pr-lg-5.test-justify
              = t(:how_to_start)
              %br
              .text-center
                %big= link_to 'https://goo.gl/jEb3Au', 'https://goo.gl/jEb3Au',
                target: '_blank'
              %hr
              = t(:with_any_troubles)
              = mail_to(Rails.application.secrets.admin_email)

app/views/home/private_index.html.haml
%h2 Hello user!
%p Visible only for signed users.
= link_to 'home page', root_path